FUNCTION(PROCESS_ANTLR GRAMMARS OUT)
	SET(antlr_SOURCE_DIR "${Master_SOURCE_DIR}/Libraries/antlr")

	SET(GENERATED "")
	FOREACH(GRAMMAR ${GRAMMARS})
		GET_FILENAME_COMPONENT(BASE "${GRAMMAR}" NAME_WE)
		SET(DST "${CMAKE_CURRENT_BINARY_DIR}/${BASE}")
		ADD_CUSTOM_COMMAND(
			OUTPUT "${DST}_lexer.cpp" "${DST}_parser.cpp" "${DST}_lexer.hpp" "${DST}_parser.hpp" "${DST}_TokenTypes.hpp" "${DST}_TokenTypes.txt"
			COMMAND "${antlr_SOURCE_DIR}/bin/gen" "${GRAMMAR}" "${CMAKE_CURRENT_BINARY_DIR}" VERBATIM
			DEPENDS "${GRAMMAR}"
			COMMENT "Generating sources for ${BASE}.g"
		)
		LIST(APPEND GENERATED "${DST}_lexer.cpp" "${DST}_parser.cpp")
	ENDFOREACH()
	SET("${OUT}" "${GENERATED}" PARENT_SCOPE)
	INCLUDE_DIRECTORIES("${CMAKE_CURRENT_BINARY_DIR}")
ENDFUNCTION()
