# PROCESS_PLIST(Info.plist OUT) #=> OUT points to build/Info.plist

FUNCTION(PROCESS_PLIST SRC OUT)
	SET(DST "${CMAKE_CURRENT_BINARY_DIR}/Info.plist")
	ADD_CUSTOM_COMMAND(
		OUTPUT "${DST}"
		COMMAND ruby > "${DST}" -pe "$_.gsub!(/\\$\\{.*_NAME\\}/, '${PROJECT_NAME}')" "${SRC}" VERBATIM
		DEPENDS "${SRC}"
		COMMENT "Pre-processing Info.plist for ${PROJECT_NAME}"
	)
	SET("${OUT}" "${DST}" PARENT_SCOPE)
ENDFUNCTION()
