FUNCTION(PROCESS_RAGEL GRAMMARS OUT)
	SET(GENERATED "")
	FOREACH(GRAMMAR ${GRAMMARS})
		GET_FILENAME_COMPONENT(BASE "${GRAMMAR}" NAME_WE)
		SET(DST "${CMAKE_CURRENT_BINARY_DIR}/${BASE}.cc")
		ADD_CUSTOM_COMMAND(
			OUTPUT "${DST}"
			COMMAND "ragel" -o "${DST}" "${GRAMMAR}" VERBATIM
			DEPENDS "${GRAMMAR}"
			COMMENT "Generating source for ${BASE}.rl"
		)
		LIST(APPEND GENERATED "${DST}")
	ENDFOREACH()
	SET("${OUT}" "${GENERATED}" PARENT_SCOPE)
	INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}/src")
ENDFUNCTION()
