# CREATE_TOOL(MyTool
# 	SOURCE_FILES   *.cc
# 	LINK_WITH      Find
# )

FUNCTION(CREATE_TOOL)
	LIST(GET ARGN 0 TOOL_NAME)
	LIST(REMOVE_AT ARGN 0)

	SET(SRC_FILES        "")
	SET(RL_FILES         "")
	SET(LINK_WITH        "")

	WHILE(ARGN)
		LIST(GET ARGN 0 TYPE)
		LIST(REMOVE_AT ARGN 0)

		IF("${TYPE}" STREQUAL "SOURCE_FILES")
			LIST(GET ARGN 0 ARG)
			LIST(REMOVE_AT ARGN 0)
			FILE(GLOB TMP "${ARG}")
			LIST(APPEND SRC_FILES ${TMP})
		ELSEIF("${TYPE}" STREQUAL "RAGEL_FILES")
			LIST(GET ARGN 0 ARG)
			LIST(REMOVE_AT ARGN 0)
			FILE(GLOB TMP "${ARG}")
			LIST(APPEND RL_FILES ${TMP})
		ELSEIF("${TYPE}" STREQUAL "LINK_WITH")
			LIST(GET ARGN 0 ARG)
			LIST(REMOVE_AT ARGN 0)
			LIST(APPEND LINK_WITH "${ARG}")
		ELSE()
			MESSAGE("Unknown type: ${TYPE}")
			RETURN()
		ENDIF()
	ENDWHILE()

	# ============================
	# = Work With Collected Info =
	# ============================

	PROJECT("${TOOL_NAME}")

	PROCESS_RAGEL("${RL_FILES}" TMP)
	LIST(APPEND SRC_FILES ${TMP})

	FOREACH(SRC ${SRC_FILES})
		IF("${SRC}" MATCHES "\\.mm$")
			SET_SOURCE_FILES_PROPERTIES("${SRC}" PROPERTIES COMPILE_FLAGS "-fobjc-call-cxx-cdtors")
		ENDIF()
	ENDFOREACH()

	ADD_EXECUTABLE("${TOOL_NAME}" ${SRC_FILES})
	TARGET_LINK_LIBRARIES("${TOOL_NAME}" ${LINK_WITH})
	ADD_DEPENDENCIES("${TOOL_NAME}" PCH)

	SET_TARGET_PROPERTIES("${TOOL_NAME}" PROPERTIES
		COMPILE_FLAGS               "-include ${PCH_BINARY_DIR}/prelude"
	)

	# ================================
	# = Create Run and Debug Targets =
	# ================================

	ADD_CUSTOM_TARGET(Run${TOOL_NAME}
		DYLD_FALLBACK_FRAMEWORK_PATH=${Frameworks_BINARY_DIR} "${${TOOL_NAME}_BINARY_DIR}/${TOOL_NAME}"
		COMMENT "Running ${TOOL_NAME}…"
	)

	ADD_DEPENDENCIES("Run${TOOL_NAME}" "${TOOL_NAME}")
ENDFUNCTION()
