# PROCESS_XIB(MainMenu.xib Resources/English.lproj OUT) #=> OUT points to build/MainMenu.nib

FUNCTION(PROCESS_XIB SRC BUNDLE_DIR OUT)
	GET_FILENAME_COMPONENT(XIB_NAME "${SRC}" NAME_WE)
	SET(DST "${CMAKE_CURRENT_BINARY_DIR}/${XIB_NAME}.nib")
	ADD_CUSTOM_COMMAND(
		OUTPUT "${DST}"
		COMMAND /Developer/usr/bin/ibtool --errors --warnings --notices --output-format human-readable-text --compile "${DST}" "${SRC}" VERBATIM
		DEPENDS "${SRC}"
		COMMENT "Compiling XIB file ${XIB_NAME}"
	)
	SET_SOURCE_FILES_PROPERTIES("${DST}" PROPERTIES MACOSX_PACKAGE_LOCATION "${BUNDLE_DIR}")
	SET("${OUT}" "${DST}" PARENT_SCOPE)
ENDFUNCTION()
